// Delphi Code Arrange Expert - (Unregisted verion)
// Please contact with Wolfgang Chien <wolfgang@ms2.hinet.net>
// or http://www.chih.com/download/ca.html to get the license key. 
// ---------------------------------------------------------------
unit global;

interface
uses Winsock, dsstream, Classes;

const
  mtInfo = 0;
  mtWarn = 1;
type
  TBuffer = array[0..255] of Byte;


procedure Log(Msg: string);
procedure FatalError(Msg: string);
procedure Error(Msg: string);
procedure SendDebugEx(Msg: string; typ: Integer);
procedure StartLog(logname: string; A: Boolean);
procedure StopLog;

implementation

uses Dialogs, Windows, SysUtils;

var logfile: TAsyncFileStream;
    logging: Boolean;
    logcons: Boolean;

procedure Log;
var
  ts: string;
begin
  if not logging then Exit;
  ts := FormatDateTime('dd mmm hh:nn', Now) + ' ' + Msg + #10 + #13;
  logfile.write (ts[1], Length(ts));
  if logcons then write (ts);
end; {_ procedure Log; _}

procedure FatalError;
begin
  //   Log('Fatal: '+msg);
  //   Log('Application terminated');
  WriteLn('Fatal: ' + Msg);
  WriteLn('Aplication terminated');
end; {_ procedure FatalError; _}

procedure Error;
begin
  Log(Msg);
  WriteLn(Msg);
end; {_ procedure Error; _}

procedure SendDebugEx;
begin
  case typ of
    mtInfo:
    begin
      Log('Debug_Info: ' + Msg);
    end; {_ mtInfo: _}
    mtWarn:
    begin
      Log('Warning: ' + Msg);
    end; {_ mtWarn: _}
  end; {_ case typ of _}
end; {_ procedure SendDebugEx; _}

procedure StartLog(logname: string; A: Boolean);
begin
  if A then
  begin
    AllocConsole;
    logcons := True;
  end; {_ if A then _}
  logfile := TAsyncFileStream.Create(logname, fmCreate);
  logging := True;
end; {_ procedure StartLog(logname: string, A: Boolean); _}

procedure StopLog;
begin
  logfile.Wait;
  logfile.Destroy;
end; {_ procedure StopLog; _}

initialization
  logging := False;
  logcons := False;
  
  
  
end.

