// Delphi Code Arrange Expert - (Unregisted verion)
// Please contact with Wolfgang Chien <wolfgang@ms2.hinet.net>
// or http://www.chih.com/download/ca.html to get the license key.
// ---------------------------------------------------------------
// Delphi Code Arrange Expert - (Unregisted verion)
// Please contact with Wolfgang Chien <wolfgang@ms2.hinet.net>
// or http://www.chih.com/download/ca.html to get the license key.
// ---------------------------------------------------------------
// Delphi Code Arrange Expert - (Unregisted verion)
// Please contact with Wolfgang Chien <wolfgang@ms2.hinet.net>
// or http://www.chih.com/download/ca.html to get the license key.
// ---------------------------------------------------------------

{$DEFINE DEBUG}

unit Socks;

interface
uses Winsock, Classes, SysUtils, Global;

type

  plongint=^longint;

  TClientSocket = class(TObject)
  protected
    sock: tSocket;
    portn:word;
  public
    Data: TStream;
    constructor Create;
    function Connect(adr: string; port: string): Word;
    function WaitForData: Word;
    function WaitForDataTime(A: Word): Word;
//    function IsAvail: Word;
    function read (var Buf; len: Word): Word;
    function write (var Buf; len: Word): Word;
//    function SendText(socket: tSocket; Text: string): Boolean;
  end; {_ TClientSocket = class(TObject) _}

  TServerSocket = class(TObject)
  protected
    sock: tSocket;
    portn: word;
  public
    constructor Create(PORT: string);
    function Listen: Word;
    function WaitForConnection: Word;
    function AcceptConnection: TClientSocket;
  end; {_ TServerSocket = class(TObject) _}

var
  WSAReady: Boolean = False;


implementation

var
  WSAData: TWSAData;

procedure StartWSA;
begin
  {$IFDEF DEBUG} SendDebugEx('Starting WSA... ', mtInfo); {$ENDIF}
  if WSAStartUp(257, WSAData) <> 0 then
  begin
    FatalError('in socks.StartWSA: WSAStartUp() failed; error code ' + IntToStr(WSAGetLastError));
    Exit;
  end; {_ if WSAStartUp(257, WSAData) <> 0 then _}
  WSAReady := True;
  {$IFDEF DEBUG} SendDebugEx('WSA: ' + WSAData.szDescription + ' ready', mtInfo); {$ENDIF}
  Log('WSA: ' + WSAData.szDescription + ' ready');
end; {_ procedure StartWSA; _}

{----------------------------- Server Socket implementation ---------------}

constructor TServerSocket.Create(PORT: String);
var
  sn : TSockAddrIn;
  PSE: PServEnt;
begin
  //inherited.Create;
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  {$IFDEF DEBUG} SendDebugEx('Binding to port ' + PORT, mtInfo); {$ENDIF}
  sock := socket(PF_INET, SOCK_STREAM, getprotobyname('tcp').p_proto);
  if sock < 0 then
  begin
    FatalError('in socks.BindTCP: socket() failed; error code ' + IntToStr(WSAGetLastError));
    Exit;
  end; {_ if MasterSocket < 0 then _}
  {$IFDEF DEBUG} SendDebugEx('master socket: ' + IntToStr(Sock), mtInfo); {$ENDIF}
  sn.sin_family := AF_INET;
  sn.sin_addr.s_addr := INADDR_ANY;
  {$IFDEF DEBUG} SendDebugEx('resolving port name ' + PORT, mtInfo); {$ENDIF}
  PSE := getservbyname(PChar(PORT), PChar('tcp'));
  if PSE = nil then
  begin
    {$IFDEF DEBUG} SendDebugEx('cannot resolv; usign port number ' + PORT, mtWarn); {$ENDIF}
    sn.sin_port := htons(StrToInt(PORT));
    portn:=StrToInt(PORT);
  end {_ if PSE = nil then _}
  else {_ NOT if PSE = nil then _}
  begin
    sn.sin_port := PSE^.s_port;
    portn:=ntohs(PSE^.s_port);
    {$IFDEF DEBUG} SendDebugEx('resolved; port number ' + IntToStr(portn), mtInfo); {$ENDIF}
  end; {_ NOT if PSE = nil then _}
  {$IFDEF DEBUG} SendDebugEx('Binding socket', mtInfo); {$ENDIF}
  if bind(sock, sn, sizeof(sn)) <> 0 then
  begin
    FatalError('in socks.BindTCP: bind() failed; error code ' + IntToStr(WSAGetLastError));
    Exit;
  end {_ if bind(MasterSocket, sn, sizeof(sn)) <> 0 then _}
  else {_ NOT if bind(MasterSocket, sn, sizeof(sn)) <> 0 then _}
  begin
    {$IFDEF DEBUG} SendDebugEx('succesful', mtInfo); {$ENDIF}
  end; {_ NOT if bind(MasterSocket, sn, sizeof(sn)) <> 0 then _}
end; {_ constructor TServerSocket.Create(PORT: Word); _}


function TServerSocket.Listen;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  {$IFDEF DEBUG} SendDebugEx('Starting listening', mtInfo); {$ENDIF}
  if Winsock.Listen(sock, 5) <> 0 then
  begin
    FatalError('in socks.ListenSocket: listen() failed; error code ' + IntToStr(WSAGetLastError));
    Exit;
  end; {_ if Listen(sock, 5) <> 0 then _}
  {$IFDEF DEBUG} SendDebugEx('succesful', mtInfo); {$ENDIF}
  Log('listening started on port '+IntToStr(portn));
  Result := 0;
end; {_ function TServerSocket.Listen; _}

function TServerSocket.WaitForConnection;
var
  fdset: TFDset;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  {$IFDEF DEBUG} SendDebugEx('Waiting for connection', mtInfo); {$ENDIF}
  fdset.fd_count := 1;
  fdset.fd_array[0] := sock;
  if Select(0, @fdset, nil, nil, nil) = SOCKET_ERROR then
  begin
    FatalError('in socks.WaitForConnect: select() failed; error code ' + IntToStr(WSAGetLastError));
    Exit;
  end; {_ if Select(0, @fdset, nil, nil, nil) = SOCKET_ERROR then _}
  Result := 0;
  {$IFDEF DEBUG} SendDebugEx('connected', mtInfo); {$ENDIF}
end; {_ function TServerSocket.WaitForConnection; _}

function TServerSocket.AcceptConnection;
var
  TmpSock: tSocket;
  sad    : TSockAddr;
  I      : Integer;
  ip     : string;
  phe    : PHostEnt;
  TmpCs  : TClientSocket;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  {$IFDEF DEBUG} SendDebugEx('Accepting connection', mtInfo); {$ENDIF}
  I := sizeof(TSockAddr);
  TmpSock := Accept(sock, @sad, @I);
  ip := IntToStr(Ord(sad.sa_data[2])) + '.' + IntToStr(Ord(sad.sa_data[3])) + '.' +
    IntToStr(Ord(sad.sa_data[4])) + '.' + IntToStr(Ord(sad.sa_data[5]));
  if TmpSock = INVALID_SOCKET then
  begin
    Error('in socks.AcceptConnection: accept() failed; error code ' + IntToStr(WSAGetLastError));
    Exit;
  end {_ if TmpSock = INVALID_SOCKET then _}
  else {_ NOT if TmpSock = INVALID_SOCKET then _}
  begin
    phe := gethostbyaddr(@(sad.sa_data[2]), 4, PF_INET);
    if phe = nil then
    begin
      Error('in socks.AcceptConnection: gethostbyaddr() failed; error code ' + IntToStr(WSAGetLastError));
      Log('[' + IntToStr(TmpSock) + '] [' + ip + '] connected');
    end {_ if phe = nil then _}
    else {_ NOT if phe = nil then _}
    begin
      Log('[' + IntToStr(TmpSock) + '] ' + phe^.h_name + ' [' + ip + '] connected');
      {$IFDEF DEBUG} SendDebugEx(phe^.h_name + ' [' + ip + '] connected', mtInfo); {$ENDIF}
    end; {_ NOT if phe = nil then _}
  end; {_ NOT if TmpSock = INVALID_SOCKET then _}
  TmpCs := TClientSocket.Create;
  TmpCs.sock := TmpSock;
  Result := TmpCs;
end; {_ function TServerSocket.AcceptConnection; _}

{--------------------- End of Server Socket inplementation ---------------}



{--------------------- Client Socket implementation ----------------------}

constructor TClientSocket.Create;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  //inherited.Create;
end; {_ constructor TClientSocket.Create; _}


function TClientSocket.Connect;
var phe:PHostEnt;
    sin:TSockAddrIn;
    pse:PServEnt;
    szData:Pchar;
begin
 sock:=Socket(PF_INET,SOCK_STREAM,getprotobyname('tcp').p_proto);
 if sock<0 then FatalError('socket Failed');
 sin.sin_family := AF_INET;
 PSE := getservbyname(PChar(PORT), PChar('tcp'));
 if PSE = nil then
  begin
   {$IFDEF DEBUG} SendDebugEx('cannot resolv; usign port number ' + PORT, mtWarn); {$ENDIF}
   sin.sin_port := htons(StrToInt(PORT));
   portn:=StrToInt(PORT);
  end {_ if PSE = nil then _}
  else {_ NOT if PSE = nil then _}
  begin
    sin.sin_port := PSE^.s_port;
    portn:=ntohs(PSE^.s_port);
    {$IFDEF DEBUG} SendDebugEx('resolved; port number ' + IntToStr(portn), mtInfo); {$ENDIF}
  end; {_ NOT if PSE = nil then _}
 szData:=PChar(adr);
 sin.sin_addr.s_addr := inet_addr(szData);
 if sin.sin_addr.s_addr = INADDR_NONE then
  begin
   {$IFDEF DEBUG} SendDebugEx('trying to resolve host name ' + adr, mtInfo); {$ENDIF}
   Phe := gethostbyname(szData);
   if Phe = nil then FatalError('Cannot resolve host');
   {$IFDEF DEBUG} SendDebugEx('resolved host name ', mtInfo); {$ENDIF}
   sin.sin_addr.S_addr := longint(plongint(Phe^.h_addr_list^)^);
 end;
 {$IFDEF DEBUG} SendDebugEx('trying to connect to '+adr+' on port '+PORT, mtInfo); {$ENDIF}
 if winsock.connect(sock,sin,sizeOf(sin))<>0 then Error('Cannot connect');
end;

function TClientSocket.WaitForData;
var
  fdset: TFDset;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  {$IFDEF DEBUG} SendDebugEx('Waiting for readability on socket ' + IntToStr(sock), mtInfo); {$ENDIF}
  fdset.fd_count := 1;
  fdset.fd_array[0] := sock;
  if Select(0, @fdset, nil, nil, nil) = SOCKET_ERROR then
  begin
    Error('in socks.WaitForConnect: select() failed; error code ' + IntToStr(WSAGetLastError));
    Result := 1;
    Exit;
  end; {_ if Select(0, @fdset, nil, nil, nil) = SOCKET_ERROR then _}
  Result := 0;
end; {_ function TClientSocket.WaitForData; _}


function TClientSocket.WaitForDataTime;
var
  fdset: TFDset;
  TM   : TTimeVal;
  Res  : Integer;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  TM.tv_sec := 0;
  TM.tv_usec := A;
  {$IFDEF DEBUG} SendDebugEx('Waiting for readability on socket ' + IntToStr(sock), mtInfo); {$ENDIF}
  fdset.fd_count := 1;
  fdset.fd_array[0] := sock;
  Res := Select(0, @fdset, nil, nil, @TM);
  if Res = SOCKET_ERROR then
  begin
    Error('in socks.WaitForConnect: select() failed; error code ' + IntToStr(WSAGetLastError));
    Result := 1;
    Exit;
  end; {_ if Res = SOCKET_ERROR then _}
  Result := 0;
end; {_ function WaitForReadTime; _}



(*  function CheckForWrite;
   var fdset:TFDset;
  begin
   {$IFDEF DEBUG} SendDebugEx('Waiting for writeability on socket',mtInformation);{$ENDIF}   mesg('Waiting for writeability on socket '+IntToStr(sock)+'...  ',False);
   FDSet.fd_count:=1;
   FDSet.fd_array[0]:=sock;
   if select(0,nil,nil,@FDSet,nil)=SOCKET_ERROR then
    begin
     mesg('in socks.WaitForConnect: select() failed; error code '+IntToStr(WSAGetLastError),True);
     Result:=False;
     exit;
    end; {_ exit; _}
   Result:=True;
   mesg('succesful',True);
  end; {_ mesg('succesful',True); _} *)


function TClientSocket.read;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  Result := recv(sock, Buf, len, 0);
  if Result = SOCKET_ERROR then
    Error('in socks.ReadBytes: recv() failed; error code ' + IntToStr(WSAGetLastError));
end; {_ function TClientSocket.read; _}

function TClientSocket.write;
begin
  if not WSAReady then
   begin
    FatalError('WSA not inialized');
    Exit;
   end;
  Result := send(sock, Buf, len, 0);
  if Result = SOCKET_ERROR then
    Error('in socks.SendBytes: send() failed; error code ' + IntToStr(WSAGetLastError));
end; {_ function TClientSocket.write; _}

(*function SendText;
var
  PBuff: PChar;
begin
  PBuff := StrAlloc(Length(Text) + 1);
  StrPCopy(PBuff, Text);
  if send(socket, PBuff^, Length(Text), 0) < 0 then
  begin
    Error('in socks.SendText: send() failed; error code ' + IntToStr(WSAGetLastError));
    Result := False;
    StrDispose(PBuff);
    Exit;
  end; {_ if send(socket, PBuff^, Length(Text), 0) < 0 then _}
  StrDispose(PBuff);
  Result := True;
end; {_ function SendText; _}*)

initialization
  StartWSA;



end.

